Page MenuHomePhabricator

OO.ui.FieldLayout broken behavior when label contains links and widget getInputId() is null
Closed, ResolvedPublic

Description

The behavior of OO.ui.FieldLayout is inconsistent (and sometimes broken) when the label contains HTML links (<a href> tags), depending on the widget used in the FieldLayout.

When the widget returns a value from getInputId(), FieldLayout behaves consistently with the HTML <label> element: clicking text focuses the widget, while clicking a link activates the link without focusing the widget.

When the widget returns null from getInputId(), however, FieldLayout always (tries to) focus the widget and never follows the link.

This regression seems to have been introduced in rGOJU383d0c89477e: Allow more widgets to be focussed programatically, although it didn't affect ApiSandbox as originally reported until rGOJUea1f002af2fe: Re-introduce .simulateLabelClick() as a separate method from .focus() due to the lack of a focus() method on OO.ui.Widget.

Demo:

new OO.ui.FieldLayout(
    new OO.ui.TextInputWidget( {} ),
    {
        label: new OO.ui.HtmlSnippet( '<a href="http://example.com">This link</a> works' ),
        align: 'top'
    }
),
new OO.ui.FieldLayout(
    new OO.ui.ButtonWidget( { label: 'Button' } ),
    {
        label: new OO.ui.HtmlSnippet( '<a href="http://example.com">This link</a> does not work' ),
        align: 'top'
    }
),

Original report:

All links in the container of the ApiSandbox don't work. You have to use the middle mouse button or select the option to open links in a new tab / window to reach the links. The links at the top of this special page do open in a new tab / window. Different browsers (Edge, Firefox, Chrome) and different wikis (nlwiki, metawiki, wikidatawiki) give the same result, so it's not specific to any browser or wiki.

I don't know if this was done for security purposes, but if it is, you can close this ticket as invalid.

Event Timeline

Wiki13 created this task.Jan 11 2018, 12:16 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJan 11 2018, 12:16 PM

Yeah... Cmd/Shift + Click on Chrome on macos don't do anything either... You have to two finger click, then "Open in...."

This appears to be a bug in OOUI, introduced in MediaWiki core with rMW766883623693: Update OOjs UI to v0.22.1. With that revision clicking the links fails, while with the previous revision it works fine. I'll update this bug to reflect the underlying cause in OOUI.

Anomie renamed this task from All links in ApiSandbox container can't be opened. to OO.ui.FieldLayout broken behavior when label contains links and widget getInputId() is null.Jan 11 2018, 4:59 PM
Anomie edited projects, added OOUI, Regression; removed MediaWiki-Special-pages.
Anomie updated the task description. (Show Details)

Change 403750 had a related patch set uploaded (by Bartosz Dziewoński; owner: Bartosz Dziewoński):
[oojs/ui@master] Allow other stuff to handle the event when we call simulateLabelClick()

https://gerrit.wikimedia.org/r/403750

Volker_E moved this task from Backlog to OOUI-0.25.1 on the OOUI board.Jan 17 2018, 12:43 AM
Volker_E edited projects, added OOUI (OOUI-0.25.1); removed OOUI.

Change 403750 merged by jenkins-bot:
[oojs/ui@master] Allow other stuff to handle the event when we call simulateLabelClick()

https://gerrit.wikimedia.org/r/403750

Volker_E closed this task as Resolved.Jan 17 2018, 1:13 AM
Volker_E assigned this task to matmarex.
Volker_E triaged this task as Normal priority.
Volker_E removed a project: Patch-For-Review.
Volker_E removed a subscriber: gerritbot.
238482n375 removed matmarex as the assignee of this task.Jun 15 2018, 8:03 AM
238482n375 lowered the priority of this task from Normal to Lowest.
238482n375 moved this task from Next Up to In Code Review on the Analytics-Kanban board.
238482n375 edited subscribers, added: matmarex, 238482n375; removed: Aklapper.

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

Aklapper assigned this task to matmarex.Jun 15 2018, 1:01 PM